(************************************************************************)
(*  RWord  1.4    Random Word Generator  łߌt             *)
(*  Copyright  1989,90  Y.Fujisawa     בS                         *)
(*  Machine:    J-3100B,SS  MS-DOS 2.11, 3.10                           *)
(*  Compiler:   TURBO-PASCAL 5.5                                        *)
(*  History:                                                            *)
(*      89-03-03    1.0     VK쐬                                    *)
(*      89-03-05    1.1     procedure ReadFile ύX@             *)
(*      89-03-08    1.2     P 1..9 Ŏw肷悤ɂ            *)
(*      89-03-23    1.3     Heap ̈gB-n IvVǉ        *)
(*      90-05-13    1.4     Turbo-Pascal 5.5 gpB                   *)
(*                          sAXy[XŌJԂȂŏI      *)
(************************************************************************)

program  RWord(input,output);
uses  Dos;

const
    WordLength = 60;        (* P̒iőj *)
    DelimiterChar = '/';    (* P̍Ō̋؂ *)
    CrChar = ^M;            (* s *)
type
    WordAttrType = 1..9;
    WordPtr = ^WordRec;
    WordRec = record
                St: string[WordLength];     (* P *)
                Attr: WordAttrType;         (*  *)
                Next: WordPtr;              (* ̒Pւ̃|C^[ *)
            end;
    VocabRec = record
                Num: integer;       (* Pꐔ *)
                Ptr: WordPtr;       (* Pւ̃|C^[ *)
               end;

var
    Vocabulary: array[WordAttrType] of VocabRec;    (* Ƃ̒P *)


(* GR[ȂŁAL[ *)
function  ReadKey: char;
var
    Regs: Registers;
begin
    Regs.AH := $08;
    MsDos(Regs);
    ReadKey := Chr(Regs.AL);
end;  { ReadKey }


(* bZ[W\ *)
procedure  WriteMessage;
begin
    Writeln('RWord Version 1.4  Date:1990-5-14  Copyright 1989,90 Y.Fujisawa');
    Writeln('Usage:  RWORD [-n] <FileName>       ( n: Repeat times )');
end;  { WriteMessage }


{$f+}
function  HeapErrorFunc(Size: word): integer;
{$f-}
begin
    Writeln('[܂ (^_^;)');
    HeapErrorFunc := 0;
end;  { HeapErrorFunc }


(* Pt@Cǂݍ *)
procedure  ReadFile(FileName: string);
var
    TextFile: text;
    LineCount: integer;
    Line: string;

    procedure  OpenFile;
    begin
        if Pos('.',FileName) = 0 then  FileName := FileName+'.RWD';
        Assign(TextFile,FileName);
        {$i-}  Reset(TextFile);  {$i+}
        if IOResult <> 0 then  begin
            Writeln('t@C܂ (^_^;)');
            Halt;
        end;  { if }
    end;  { OpenFile }

    procedure  ReadLine;

        procedure  ErrorExit;
        begin
            Writeln(LineCount:3,' sڂł (^_^;)');
            Writeln('-->',Line);
            Close(TextFile);
            Halt;
        end;   { ErrorExit }

        function  GetWordAttr(Ch: char): WordAttrType;
        begin
            case UpCase(Ch) of
                '1'..'9':   GetWordAttr := Ord(Ch)-Ord('0');
                'A' :       GetWordAttr := 1;
                'N' :       GetWordAttr := 2;
                else    ErrorExit;
            end;  { case }
        end;  { GetWordType }

    var
        p: byte;
        at: WordAttrType;
        NewWord: WordPtr;
    begin
        Readln(TextFile, Line);
        Inc(LineCount);
        p := Pos(DelimiterChar,Line);
        if (p > 0) and ( p < Length(Line) ) then  begin
            New(NewWord);
            at := GetWordAttr(Line[p+1]);
            with NewWord^ do  begin
                St := Copy(Line,1,p-1);
                Attr := at;
                with Vocabulary[at] do  begin
                    Next := Ptr;
                    Ptr := NewWord;
                    Inc(Num);
                end;  { with }
            end;  { with }
        end  { if }
        else  ErrorExit;
    end;  { ReadLine }

var
    i: integer;
begin
    LineCount := 0;
    for i := 1 to 9 do  begin
        with Vocabulary[i] do  begin
            Num := 0;
            Ptr := nil;
        end;  { with }
    end;  { for }
    OpenFile;
    while not Eof(TextFile) do ReadLine;
    Close(TextFile);
end;  { ReadFile }


(* ŒPgݍ킹 *)
function  RandomWord: string;

    function Scan(Ptr: WordPtr; n: integer): string;
    var
        i: integer;
    begin
        for i := 1 to n-1 do  Ptr := Ptr^.Next;
        Scan := Ptr^.St;
    end;  { Scan }

var
    s: string;
    at: WordAttrType;
begin
    s := '';
    for at := 1 to 9 do  begin
        with Vocabulary[at] do  begin
            if Num > 0 then  s := s+Scan(Ptr,Random(Num)+1);
        end;  { with }
    end;  { for }
    RandomWord := s;
end;  { RandomWord }


(* JԂ̉񐔂𓾂 *)
function  GetRepeat(St: string): integer;

    procedure  ErrorExit;
    begin
        Writeln('JԂ̎w肪ł (^_^;)');
        Halt;
    end;  { ErrorExit }

var
    Num,Result: integer;
begin
    if St[1] = '-' then  begin
        Delete(St,1,1);
        Val(St,Num,Result);
        if Result = 0 then
            GetRepeat := Num
        else
            ErrorExit;
    end  { if }
    else  ErrorExit;
end;  { GetRepeat }


var
    RepeatTimes,i: integer;
begin
    HeapError := @HeapErrorFunc;
    Randomize;
    case ParamCount of
        1:  begin
                ReadFile(ParamStr(1));
                repeat
                    WriteLn;
                    Write(RandomWord);
                until  not(ReadKey in [CrChar,' ']);
            end;
        2:  begin
                RepeatTimes := GetRepeat(ParamStr(1));
                ReadFile(ParamStr(2));
                for i := 1 to RepeatTimes do  Writeln(RandomWord);
            end;
        else    WriteMessage;
    end;  { case }
end.

